function [find1,find7,side_cable_a,side_cable_b,side_cable_c,side_cable_d,cable_geo_8000_test, cable_geo_6000_test, cross_beam_geo_2000, cross_beam_geo_4000, crossbeam_pylonbed_1, crossbeam_pylonbed_end, crossbeam_pylontop_1, crossbeam_pylontop_end,crossbeam_pylonmid_1,crossbeam_pylonmid_end, crossbeams_pylon, Girder_geo_2000_test, Girder_geo_4000_test, Girder_geo_main_test, K2, K3, main_nodes_geo, pylon_geo, pylon_geo_6000_1, pylon_geo_6000_end, pylon_geo_8000_1, pylon_geo_8000_end,side_cables_geo_test] = geometry (d,D,D_pylon,e_vert,girder_sag,h,hangers,L,L_side,sag,subheight)
%% This script creates the undeformed geometry of the model, before gravity is applied. 
% All the nodes is given spacial coordinates.
%% Create main girder nodes
l= L/(hangers+1); %length between hangers
x_pos = -L/2 ;
x_neg = L/2;
o=(hangers-1)/2+2;
for i=1:o
    value(i,:)= [x_pos x_neg];
    x_pos = x_pos+l ;
    x_neg = x_neg-l;
end
a=value(:,1);
b=flip(value(:,2));
a(a==0)=[];
b(b==0)=[];
main_nodes_geo=[a;0;b];


a=1;
b=501;
k=1;
    c= main_nodes_geo(1);
for i=1:length(main_nodes_geo)
    c= main_nodes_geo(i);
    Girder_geo_main_test(k,:)= [a c 0 0];% [ element_nr , x , y , z ]
      if c==L/2
        break
      end
      if i==floor((length(main_nodes_geo)-1)/2);
          k=k+1;
    a=a+1;
    continue
      end
     if c==0
             k=k+1;
    a=a+1;
            continue
        end
    for j=1:7
        c=c+l/8;
        Girder_geo_main_test(k+j,:)=[b c 0 0];
        b=b+1;
    end
    k=k+j+1;
    a=a+1;
end

%% Curving main girder
syms m n
Eqn1 = m*(L/2)^2 + n* (L/2) + girder_sag; %creating z direction parabola
Eqn2 = m*(-L/2)^2 + n*(-L/2) + girder_sag;

[sol_m,sol_n]= solve(Eqn1==0,Eqn2==0);
M=double(sol_m);
N=double(sol_n);
x_girder = Girder_geo_main_test(:,2);
for i=1:length(x_girder)
    z_girder_main(i) = M*x_girder(i).^2 + N*x_girder(i) + girder_sag;
end

for i=1:length(Girder_geo_main_test)
    Girder_geo_main_test(i,4) = z_girder_main(i);
end
%% Create 2000-girder geometry
a=2001;
b=2501;
k=1;
for i=1:length(main_nodes_geo)
    c= main_nodes_geo(i);
    Girder_geo_2000_test(k,:)= [a c -d e_vert];
      if c==L/2
        break
      end
      if i==floor((length(main_nodes_geo)-1)/2);
          k=k+1;
    a=a+1;
    continue
      end
     if c==0
             k=k+1;
    a=a+1;
            continue
        end
    for j=1:7
        c=c+l/8;
        Girder_geo_2000_test(k+j,:)=[b c -d e_vert];
        b=b+1;
    end
    k=k+j+1;
    a=a+1;
end

%% Curving 2000 girder
syms m n
Eqn1 = m*(L/2)^2 + n* (L/2) + girder_sag+e_vert; %creating z direction parabola
Eqn2 = m*(-L/2)^2 + n*(-L/2) + girder_sag+e_vert;

[sol_m,sol_n]= solve(Eqn1==0,Eqn2==0);
M=double(sol_m);
N=double(sol_n);
x_girder = Girder_geo_main_test(:,2);
for i=1:length(x_girder)
    z_girder_side(i) = M*x_girder(i).^2 + N*x_girder(i)+e_vert+ girder_sag;
end

for i=1:length(Girder_geo_main_test)
    Girder_geo_2000_test(i,4) = z_girder_side(i);
end

%% Create 4000-girder geometry
a=4001;
b=4501;
k=1;
for i=1:length(main_nodes_geo)
    c= main_nodes_geo(i);
    Girder_geo_4000_test(k,:)= [a c d e_vert];
      if c==L/2
        break
      end
      if i==floor((length(main_nodes_geo)-1)/2);
          k=k+1;
    a=a+1;
    continue
      end
     if c==0
             k=k+1;
    a=a+1;
            continue
        end
    for j=1:7
        c=c+l/8;
        Girder_geo_4000_test(k+j,:)=[b c d e_vert];
        b=b+1;
    end
    k=k+j+1;
    a=a+1;
end

%% Curving 4000 girder

for i=1:length(Girder_geo_main_test)
    Girder_geo_4000_test(i,4) = z_girder_side(i);
end
%% Create main cable geometry
syms a b
Eqn1 = a*(L/2)^2 + b* (L/2) + h; %creating z direction parabola
Eqn2 = a*(-L/2)^2 + b*(-L/2) + h;
 
syms e f
Eqn3 = e*(L/2)^2 - f* (L/2) + D/2; %creating z direction parabola
Eqn4 = e*(-L/2)^2 - f*(-L/2) + D/2;
sagz = D/2-D_pylon;


[sol_a,sol_b]= solve(Eqn1==sag,Eqn2==sag);
A=double(sol_a);
B=double(sol_b);
x_girder = Girder_geo_main_test(:,2);

[sol_e,sol_f]= solve(Eqn3==D_pylon/2,Eqn4==D_pylon/2);
E=double(sol_e);
F=double(sol_f);
n=length(x_girder);

z_cable = zeros(n,1);
y_cable = zeros(n,1);

for i=1:length(x_girder)
    z_cable(i) = A*x_girder(i).^2 + B*x_girder(i) + h;
end
for i=1:n
    if D_pylon==D
        y_cable(:)=D/2;
        break
    else
    y_cable(i) = E*x_girder(i).^2 + F*x_girder(i) + D/2;
    end
end
a=6001;
b=8001;


k=1;
for i=1:length(Girder_geo_main_test) %Creating main girder geometry
    c= x_girder(i);
    p =z_cable(i);
    q= y_cable(i);
    cable_geo_6000_test(i,:)= [a c q p]; %[element nr,x-cord.,y-cord,z-cord]
    cable_geo_8000_test(i,:)= [b c -q p];
    c=c+l/8;
    a=a+1;
    b=b+1; 
    k=k+1;
end

%% Create side cable geometry

f=L_side/21; %Assigning 21 nodes in each side cable
x_a=-L/2-L_side;
x_b= L/2+L_side;
a=16000;
z_a=0;
    y_a= -D/2;
    y_b= D/2;
num_el= 21;
for i=1:num_el-1
    element_nr_a = 16000+i;
    element_nr_b = 16050+i;
    element_nr_c = 16100+i;
    element_nr_d = 16150+i;
    x_a= x_a+f;
    x_b= x_b-f;
%     y_a= -D_pylon/2;
%     y_b= D_pylon/2;
    z_a= z_a;
    side_cable_a(i,:)=[element_nr_a,x_a,y_a,z_a];
    side_cable_b(i,:)=[element_nr_b,x_a,y_b,z_a];
    side_cable_c(i,:)=[element_nr_c,x_b,y_a,z_a];
    side_cable_d(i,:)=[element_nr_d,x_b,y_b,z_a];
    if i==num_el
            side_cable_a(i,:)=cable_geo_8000(1,:);
            side_cable_b(i,:)=cable_geo_6000(1,:);
            side_cable_c(i,:)=cable_geo_8000(end,:);
            side_cable_d(i,:)=cable_geo_6000(end,:);
    end
    z_a= z_a+sag/20;
    y_a= y_a +(D-D_pylon)/40;
    y_b= y_b -(D-D_pylon)/40;
end


side_cables_geo_test = [side_cable_a;side_cable_b;side_cable_c;side_cable_d];

%% Create cross beam nodes

z=length(main_nodes_geo);
k=1;
 y_cb=0;
 z_cb=Girder_geo_main_test(1,4);

for i=1:z
    a= main_nodes_geo(i);
    b= find(Girder_geo_2000_test(:,2)==a);
    g= main_nodes_geo(i);
    h= find(Girder_geo_4000_test(:,2)==g);
    findval=find(Girder_geo_2000_test(:,2)==main_nodes_geo(i));
    z_cb= Girder_geo_main_test(findval,4);
    for j=1:4*d
        node_nr_2000 = 20000+k;
        node_nr_4000 = 40000+k;
        x_cb = main_nodes_geo(i);
        y_cb = y_cb + 0.25;
%         findval=find(Girder_geo_2000_test(:,2)==main_nodes_geo(i));
        z_side=Girder_geo_2000_test(findval,4);
%         z_mid = Girder_geo_main_test(findval,4);
        z_cb = z_cb+ (Girder_geo_2000_test(findval,4)-Girder_geo_main_test(findval,4))/(4*d);
        cross_beam_geo_4000(k,:) =[node_nr_4000 , x_cb , y_cb , z_cb];%Girder_geo_4000_test(h,4)+ 
        cross_beam_geo_2000(k,:) = [node_nr_2000 , x_cb , -y_cb , z_cb];%Girder_geo_2000_test(b,4)+
     
        k=k+1;
    end
      y_cb=0;

    
end

 K2=find(cross_beam_geo_2000(:,3)==-d);
 K3=find(cross_beam_geo_4000(:,3)==d);


%% Pylon geometry

x_1= cable_geo_6000_test(1,2);
x_end = cable_geo_6000_test(end,2);
y= cable_geo_6000_test(1,3);
z= cable_geo_6000_test(1,4);

dx= Girder_geo_4000_test(1,3)-cable_geo_6000_test(1,2);
dy= Girder_geo_4000_test(1,3)+1-cable_geo_6000_test(1,3);
dz= Girder_geo_4000_test(1,4)-cable_geo_6000_test(1,4);
step_z=0;
step_y=0;

node_nr_6000_1= 100001;
node_nr_8000_1= 102001;
node_nr_6000_end=101001;
node_nr_8000_end=103001;
for i=1:41
    y=y+step_y;
    z=z+step_z;
    pylon_geo_6000_1(i,:) = [node_nr_6000_1,x_1 , y , z];
    node_nr_6000_1=node_nr_6000_1+1;
    
    pylon_geo_8000_1(i,:) = [node_nr_8000_1,x_1 , -y , z];
    node_nr_8000_1=node_nr_8000_1+1;
    
    pylon_geo_6000_end(i,:) = [node_nr_6000_end , x_end , y , z];
    node_nr_6000_end=node_nr_6000_end+1;
    
    pylon_geo_8000_end(i,:) = [node_nr_8000_end , x_end , -y , z];
    node_nr_8000_end=node_nr_8000_end+1;
step_z=dz/40;
step_y=dy/40;
end
find1= find(pylon_geo_6000_1(:,4)==0);
find7=floor(length(pylon_geo_6000_1)/2);

find2=find(pylon_geo_6000_1(:,4)==sag);
pylon_geo_6000_1(find2,:)=cable_geo_6000_test(1,:);
pylon_geo_6000_end(find2,:)=cable_geo_6000_test(end,:);
pylon_geo_8000_1(find2,:)=cable_geo_8000_test(1,:);
pylon_geo_8000_end(find2,:)=cable_geo_8000_test(end,:);

c=i+1;
z= Girder_geo_2000_test(1,4);
y= Girder_geo_2000_test(1,3)-1
dz= subheight/10;
for i=1:10
    z=z-dz;
    y=y-step_y;
    
    pylon_geo_6000_1(c,:) = [node_nr_6000_1,x_1 , -y , z];
    pylon_geo_6000_end(c,:) = [node_nr_6000_end,x_end , -y , z];
    pylon_geo_8000_1(c,:) = [node_nr_8000_1,x_1 , y , z];
    pylon_geo_8000_end(c,:) = [node_nr_8000_end,x_end , y , z];
      
    node_nr_6000_1=node_nr_6000_1+1;
      node_nr_8000_1=node_nr_8000_1+1;
      node_nr_6000_end=node_nr_6000_end+1;
      node_nr_8000_end=node_nr_8000_end+1;
    c=c+1;
end
pylon_geo = [pylon_geo_6000_1; pylon_geo_6000_end;pylon_geo_8000_1;pylon_geo_8000_end];

%% Create pylon_crossbeams
x=pylon_geo_6000_1(1,2);
y1=pylon_geo_6000_1(1,3);
y2=pylon_geo_8000_1(1,3);
z=pylon_geo_6000_1(1,4);
dy=(y1-y2)/10;

node_nr_1=120000;
node_nr_end=130000;
for i=1:9 %cross beam for pylon top
    node_nr_1=node_nr_1+1
    node_nr_end=node_nr_end+1
    y1=y1-dy;
    crossbeam_pylontop_1(i,:)= [node_nr_1 , x , y1 , z];
    crossbeam_pylontop_end(i,:)= [node_nr_end , -x , y1 , z];
end

node_nr_1=140000;
node_nr_end=150000;
y1=pylon_geo_6000_1(find1,3);
y2=pylon_geo_8000_1(find1,3);
z=pylon_geo_6000_1(find1,4)-0.1;
dy=(y1-y2)/10;
for i=1:9 %cross beam for girder bed
    node_nr_1=node_nr_1+1
    node_nr_end=node_nr_end+1
    y1=y1-dy;
    crossbeam_pylonbed_1(i,:)= [node_nr_1 , x , y1 , z];
    crossbeam_pylonbed_end(i,:)= [node_nr_end , -x , y1 , z];
end

node_nr_1=140000;
node_nr_end=150000;
y1=pylon_geo_6000_1(find1,3);
y2=pylon_geo_8000_1(find1,3);
z=pylon_geo_6000_1(find1,4)-0.1;
dy=(y1-y2)/10;
for i=1:9 %cross beam for girder bed
    node_nr_1=node_nr_1+1
    node_nr_end=node_nr_end+1
    y1=y1-dy;
    crossbeam_pylonbed_1(i,:)= [node_nr_1 , x , y1 , z];
    crossbeam_pylonbed_end(i,:)= [node_nr_end , -x , y1 , z];
end

node_nr_1=160000;
node_nr_end=170000;
y1=pylon_geo_6000_1(find7,3);
y2=pylon_geo_8000_1(find7,3);
z=pylon_geo_6000_1(find7,4);
dy=(y1-y2)/10;
for i=1:9 %cross beam for mid pylon
    node_nr_1=node_nr_1+1
    node_nr_end=node_nr_end+1
    y1=y1-dy;
    crossbeam_pylonmid_1(i,:)= [node_nr_1 , x , y1 , z];
    crossbeam_pylonmid_end(i,:)= [node_nr_end , -x , y1 , z];
end

    crossbeams_pylon= [crossbeam_pylonbed_1;crossbeam_pylonbed_end;crossbeam_pylontop_1;crossbeam_pylontop_end;crossbeam_pylonmid_1;crossbeam_pylonmid_end];
end