function [] = writefile(number_of_girders,Cp,Cp_1,Dp,Dp_1,Dp_2,Ep,Ep_1,Fp,Fp_1,Fp_2,Gp,Gp_1,Gp_2,Bp,Bp_1,Bp_2,Ap_2,Ap_1,Ap,JobName,K2,side_cable_a,side_cable_b,side_cable_c,side_cable_d,pylon_geo_6000_1,pylon_geo_6000_end,pylon_geo_8000_1,pylon_geo_8000_end,Girder_geo_main_test,Girder_geo_2000_test,Girder_geo_4000_test,cross_beam_geo_2000,cross_beam_geo_4000,cable_geo_6000_test,cable_geo_8000_test,side_cables_geo_test,pylon_geo,crossbeams_pylon,cable_el_8000,cable_el_6000,Girder_el_main_test,cross_beam_el_2000,cross_beam_el_4000,Girder_el_2000_test,Girder_el_4000_test,hanger_2000_el,hanger_4000_el,pylon_el,crossbeam_pylonbed_1_el,crossbeam_pylonbed_end_el,crossbeam_pylontop_1_el,crossbeam_pylontop_end_el,crossbeam_pylonmid_1_el,crossbeam_pylonmid_end_el)
%% Description
%This function writes the data from geometry.m and elements.m to the Abaqus
%input file. The Analysis is set-up and specified in the text-file.



%% create file
clc
% JobName='suspension_bridge';
folder = mkdir(JobName);
save1= [JobName '\' JobName '.inp'];
fid = fopen(save1,'wt');

%% Main geometry
fprintf(fid,['********************************** \n']);
fprintf(fid,['** NODES AND GEOMETRY \n']);
fprintf(fid,['********************************** \n']);

%Girder nodes
fprintf(fid,['** GIRDER NODES \n']);
fprintf(fid,[ '*NODE,NSET=GIRDERNODES \n']);
formatSpec = '%.0f,%.5f,%.5f,%.5f \n'; %first number integer, then 5 dec, 5 dec, 5 dec
fprintf(fid,formatSpec,Girder_geo_main_test'); %Print girder
fprintf(fid,['** GIRDER 2000 NODES \n']);
fprintf(fid,[ '*NODE,NSET=GIRDER_2000_NODES \n']);
formatSpec = '%.0f,%.5f,%.5f,%.5f \n'; %first number integer, then 5 dec, 5 dec, 5 dec
fprintf(fid,formatSpec,Girder_geo_2000_test');
fprintf(fid,['** GIRDER 4000 NODES \n']);
fprintf(fid,[ '*NODE,NSET=GIRDER_4000_NODES \n']);
formatSpec = '%.0f,%.5f,%.5f,%.5f \n'; %first number integer, then 5 dec, 5 dec, 5 dec
fprintf(fid,formatSpec,Girder_geo_4000_test');

%Cross beam nodes
fprintf(fid,['** CROSS BEAM NODES \n']);
fprintf(fid,[ '*NODE,NSET=CROSS_BEAM_NODES \n']);
formatSpec = '%.0f,%.5f,%.5f,%.5f \n'; %first number integer, then 5 dec, 5 dec, 5 dec
fprintf(fid,formatSpec,cross_beam_geo_2000'); %Print girder
fprintf(fid,formatSpec,cross_beam_geo_4000'); %Print girder

% Cable nodes
fprintf(fid,['** CABLE NODES \n']);
fprintf(fid,[ '*NODE,NSET=CABLENODES \n']);
formatSpec = '%.0f,%.5f,%.5f,%.5f \n'; %first number integer, then 5 dec, 5 dec, 5 dec
fprintf(fid,formatSpec,cable_geo_6000_test'); %print to file
fprintf(fid,formatSpec,cable_geo_8000_test'); %print to file

% Cable side nodes
fprintf(fid,['** CABLE SIDE NODES \n']);
fprintf(fid,[ '*NODE,NSET=CABLE_SIDE_NODES \n']);
formatSpec = '%.0f,%.5f,%.5f,%.5f \n'; %first number integer, then 5 dec, 5 dec, 5 dec
fprintf(fid,formatSpec,side_cables_geo_test'); %print to file

%Pylon nodes
fprintf(fid,['** PYLON NODES \n']);
fprintf(fid,[ '*NODE,NSET=PYLON_NODES \n']);
formatSpec = '%.0f,%.5f,%.5f,%.5f \n'; %first number integer, then 5 dec, 5 dec, 5 dec
fprintf(fid,formatSpec,pylon_geo'); %print to file

%Pylon crossbeam nodes
fprintf(fid,['** PYLON_BEAM_NODES \n']);
fprintf(fid,[ '*NODE,NSET=PYLON_BEAM_NODES \n']);
formatSpec = '%.0f,%.5f,%.5f,%.5f \n'; %first number integer, then 5 dec, 5 dec, 5 dec
fprintf(fid,formatSpec,crossbeams_pylon'); %print to file
%%
% Cable elements
fprintf(fid,['** \n']);
fprintf(fid,['**CABLE ELEMENTS \n']);
fprintf(fid,[ '*ELEMENT, TYPE=' 'B31' ', ELSET='  'CABLEELEMENTS' '\n']);
formatSpec = '%.0f, %.0f, %.0f \n'; %all three integer
fprintf(fid,formatSpec,cable_el_8000')
fprintf(fid,formatSpec,cable_el_6000')

% Girder elements
fprintf(fid,['** \n']);
fprintf(fid,['**GIRDER ELEMENTS \n']);
fprintf(fid,[ '*ELEMENT, TYPE=' 'B32' ', ELSET='  'GIRDERELEMENTS' '\n']);
formatSpec = '%.0f,%.0f, %.0f, %.0f \n'; %all three integer
fprintf(fid,formatSpec,Girder_el_main_test'); %print element number

% Cross beam elements
fprintf(fid,['** \n']);
fprintf(fid,['**CROSS BEAM ELEMENTS \n']);
fprintf(fid,[ '*ELEMENT, TYPE=' 'B32' ', ELSET='  'CROSS_BEAM_ELEMENTS' '\n']);
formatSpec = '%.0f,%.0f, %.0f, %.0f \n'; %all three integer
fprintf(fid,formatSpec,cross_beam_el_2000'); %print element number
fprintf(fid,formatSpec,cross_beam_el_4000'); %print element number

%Girder 2000 elements
fprintf(fid,['** \n']);
fprintf(fid,['**GIRDER 2000 ELEMENTS \n']);
fprintf(fid,[ '*ELEMENT, TYPE=' 'B32' ', ELSET='  'GIRDER_2000_ELEMENTS' '\n']);
formatSpec = '%.0f,%.0f, %.0f, %.0f \n'; %all three integer
fprintf(fid,formatSpec,Girder_el_2000_test'); %print element number

%Girder 4000 elements
fprintf(fid,['** \n']);
fprintf(fid,['**GIRDER 4000 ELEMENTS \n']);
fprintf(fid,[ '*ELEMENT, TYPE=' 'B32' ', ELSET='  'GIRDER_4000_ELEMENTS' '\n']);
formatSpec = '%.0f,%.0f, %.0f, %.0f \n'; %all three integer
fprintf(fid,formatSpec,Girder_el_4000_test'); %print element number

% Hanger elements
fprintf(fid,['** \n']);
fprintf(fid,['**HANGER ELEMENTS \n']);
fprintf(fid,[ '*ELEMENT, TYPE=' 'B31' ', ELSET='  'HANGERELEMENTS' '\n']);
formatSpec = '%.0f, %.0f, %.0f \n'; %all three integer
fprintf(fid,formatSpec,hanger_2000_el'); %print element number
fprintf(fid,formatSpec,hanger_4000_el'); %print element number

%Pylon elements

fprintf(fid,['** \n']);
fprintf(fid,['**PYLON ELEMENTS \n']);
fprintf(fid,[ '*ELEMENT, TYPE=' 'B32' ', ELSET='  'PYLON_ELEMENTS' '\n']);
formatSpec = '%.0f,%.0f, %.0f, %.0f \n'; %all three integer
fprintf(fid,formatSpec,pylon_el'); %print element number

fprintf(fid,['** \n']);
fprintf(fid,['**PYLON_BEAM_ELEMENTS \n']);
fprintf(fid,[ '*ELEMENT, TYPE=' 'B32' ', ELSET='  'PYLON_BEAM_ELEMENTS' '\n']);
formatSpec = '%.0f, %.0f, %.0f, %.0f \n'; %all three integer
fprintf(fid,formatSpec,crossbeam_pylonbed_1_el'); %print element number
fprintf(fid,formatSpec,crossbeam_pylonbed_end_el'); %print element number
fprintf(fid,formatSpec,crossbeam_pylontop_1_el'); %print element number
fprintf(fid,formatSpec,crossbeam_pylontop_end_el'); %print element number
fprintf(fid,formatSpec,crossbeam_pylonmid_1_el'); %print element number
fprintf(fid,formatSpec,crossbeam_pylonmid_end_el'); %print element number


%% Create sections

fprintf(fid,[ '*BEAM GENERAL SECTION, ELSET=GIRDERELEMENTS, SECTION=GENERAL, DENSITY=0  \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f,%.5f,%.5f \n', Ap );  %A. Iy, Izy, Iz, It, , Iw
fprintf(fid,[ '0,1,0  \n']);
fprintf(fid,'%.5e,%.5e \n', Ap_1);

% Create Added Inertia FOR MAIN GIRDER
fprintf(fid,[ '*BEAM ADDED INERTIA \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f,%.5f \n',Ap_2);


%Create Section for girder 2000
fprintf(fid,[ '*BEAM GENERAL SECTION, ELSET=GIRDER_2000_ELEMENTS, SECTION=GENERAL, DENSITY=0  \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f,%.5f,%.5f \n', Bp );  %A. Iy, Izy, Iz, It, , Iw
fprintf(fid,[ '0,1,0  \n']);
fprintf(fid,'%.5e,%.5e \n', Bp_1);
% Create Added Inertia FOR SIDE GIRDERS
fprintf(fid,[ '*BEAM ADDED INERTIA \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f,%.5f \n',Bp_2);

% 
fprintf(fid,[ '*BEAM GENERAL SECTION, ELSET=GIRDER_4000_ELEMENTS, SECTION=GENERAL, DENSITY=0  \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f,%.5f,%.5f \n', Bp );  %A. Iy, Izy, Iz, It, , Iw
fprintf(fid,[ '0,1,0  \n']);
fprintf(fid,'%.5e,%.5e \n', Bp_1);
% 
% Create Added Inertia FOR SIDE GIRDERS
fprintf(fid,[ '*BEAM ADDED INERTIA \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f,%.5f \n',Bp_2);

% Create Section for cables
fprintf(fid,[ '*BEAM GENERAL SECTION, ELSET=CABLEELEMENTS, SECTION=GENERAL, ROTARY INERTIA=EXACT,DENSITY=8400  \n']);
fprintf(fid,'%.5f,%.5e,%.5e,%.5e,%.5e \n', Cp );  %A. Iy, Izy, Iz, It, , Iw
fprintf(fid,[ '0,1,0  \n']);
fprintf(fid,'%.5e,%.5e \n', Cp_1);

% Create Section for cross beam
fprintf(fid,[ '*BEAM GENERAL SECTION, ELSET=CROSS_BEAM_ELEMENTS, SECTION=GENERAL, DENSITY=0  \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f,%.5f,%.5f \n', Dp );  %A. Iy, Izy, Iz, It, , Iw
fprintf(fid,[ '0,0,1  \n']);
fprintf(fid,'%.5e,%.5e \n', Dp_1);
% Create Added Inertia FOR CROSS BEAMS
fprintf(fid,[ '*BEAM ADDED INERTIA \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f,%.5f \n',Dp_2);

% Create Section for hangers
fprintf(fid,[ '*BEAM GENERAL SECTION, ELSET=HANGERELEMENTS, SECTION=GENERAL, ROTARY INERTIA=EXACT, DENSITY=8400  \n']);
fprintf(fid,'%.5f,%.5e,%.5e,%.5e,%.5e \n', Ep );  %A. Iy, Izy, Iz, It, , Iw
fprintf(fid,[ '0,1,0  \n']);
fprintf(fid,'%.5e,%.5e \n', Ep_1);

% Create Section for pylons
fprintf(fid,[ '*BEAM GENERAL SECTION, ELSET=PYLON_ELEMENTS, SECTION=GENERAL, ROTARY INERTIA=EXACT, DENSITY=2500  \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f\n', Fp );  %A. Iy, Izy, Iz, It, , Iw
fprintf(fid,[ '0,1,0  \n']);
fprintf(fid,'%.5e,%.5e,%.5e \n', Fp_1);
fprintf(fid,[ '*TRANSVERSE SHEAR STIFFNESS \n']);
fprintf(fid,'%.5e,%.5e \n', Fp_2);


% Create Section for pylons
fprintf(fid,[ '*BEAM GENERAL SECTION, ELSET=PYLON_BEAM_ELEMENTS, SECTION=GENERAL, DENSITY=0  \n']);
fprintf(fid,'%.5f,%.5f,%.5f,%.5f,%.5f \n', Gp );  %A. Iy, Izy, Iz, It, , Iw
fprintf(fid,[ '0,0,1  \n']);
fprintf(fid,'%.5e,%.5e,%.5e \n', Gp_1);
fprintf(fid,[ '*TRANSVERSE SHEAR STIFFNESS \n']);
fprintf(fid,'%.5e,%.5e \n', Gp_2);

%%
fprintf(fid,[ '**  Static step 3: Adding Hangers. Removing hanger loads \n']);
fprintf(fid,[ '*STEP, AMPLITUDE=RAMP, NLGEOM, INC=10000  \n']);
fprintf(fid,[ '**  \n']);
fprintf(fid,[ '*STATIC  \n']);
fprintf(fid,[ '0.0001, 1   \n']);
fprintf(fid,[ '**  \n']);
%Assigning nodes for boundary conditions
bc_1 = Girder_geo_main_test(1,1); %girder end
bc_2 = Girder_geo_main_test(end,1);%girder end
% bc_3 = Girder_geo_2000_test(1,1);%girder end 
bc_3 = cross_beam_geo_2000(K2(1),1);
% bc_4 = Girder_geo_2000_test(end,1);%girder end
bc_4 = cross_beam_geo_2000(K2(end),1);
% bc_5 = Girder_geo_4000_test(1,1);%girder end
bc_5 = cross_beam_geo_4000(K2(1),1);
% bc_6 = Girder_geo_4000_test(end,1);%girder end
bc_6 = cross_beam_geo_4000(K2(end),1);
bc_7 = cable_geo_6000_test(1,1); %cable 6000 top
bc_8 = cable_geo_6000_test(end,1);%cable 6000 top
bc_9 = cable_geo_8000_test(1,1);%cable 8000 top
bc_10 = cable_geo_8000_test(end,1);%cable 8000 top
bc_11 = side_cable_a(1,1);% side cable end
bc_12 = side_cable_b(1,1);% side cable end
bc_13 = side_cable_c(1,1);% side cable end
bc_14 = side_cable_d(1,1);% side cable end
mid_el = ceil(length(Girder_geo_main_test)/2);
bc_15 = Girder_geo_main_test(mid_el);
bc_16 = Girder_geo_2000_test(mid_el);
bc_17 = Girder_geo_4000_test(mid_el);

bc_18=pylon_geo_6000_1(end,1);
bc_19=pylon_geo_6000_end(end,1);
bc_20=pylon_geo_8000_1(end,1);
bc_21=pylon_geo_8000_end(end,1);

% bc_cable_top= [bc_7,2,3,0;bc_8,2,3,0;bc_9,2,3,0;bc_10,2,3,0];
% Uncomment bc_cable_top to fix the cable instead of using pylons.
bc_cable_end=[bc_11,1,6,0;bc_12,1,6,0;bc_13,1,6,0;bc_14,1,6,0];
bc_girder_step3 = [bc_1,2,4,0;bc_2,2,4,0;bc_3,2,4,0;bc_4,2,4,0;bc_5,2,4,0;bc_6,2,4,0];
bc_pylon_step3 = [bc_18,1,6,0;bc_19,1,6,0;bc_20,1,6,0;bc_21,1,6,0];
fprintf(fid,[ '**  \n']);
if number_of_girders==1
fprintf(fid,[ '*MODEL CHANGE, REMOVE  \n']);
fprintf(fid,[ 'GIRDER_2000_ELEMENTS  \n']);
fprintf(fid,[ 'GIRDER_4000_ELEMENTS  \n']);
end
if number_of_girders==2
fprintf(fid,[ '*MODEL CHANGE, REMOVE  \n']);
fprintf(fid,[ 'GIRDERELEMENTS  \n']);
end
fprintf(fid,[ '**  \n']);
fprintf(fid,[ '*BOUNDARY,OP=NEW  \n']);
formatSpec = '%.0f,%.0f,%.0f,%.0f \n';
fprintf(fid,formatSpec,bc_girder_step3'); %Girder BC
% fprintf(fid,formatSpec,bc_cable_top'); %Cable BC
fprintf(fid,formatSpec,bc_cable_end'); %Cable BC
fprintf(fid,formatSpec,bc_pylon_step3'); %Pylon BC
fprintf(fid,[ '**  \n']);

%Create gravity load
fprintf(fid,[ '*DLOAD,OP=NEW \n']);
fprintf(fid,[ 'CABLEELEMENTS, GRAV, 9.81, 0 , 0 , -1  \n']);
fprintf(fid,[ 'HANGERELEMENTS,GRAV, 9.81, 0 , 0 , -1 \n']);
fprintf(fid,[ 'GIRDERELEMENTS, GRAV, 9.81, 0 , 0 , -1  \n']);
fprintf(fid,[ 'GIRDER_2000_ELEMENTS,GRAV, 9.81, 0 , 0 , -1 \n']);
fprintf(fid,[ 'GIRDER_4000_ELEMENTS, GRAV, 9.81, 0 , 0 , -1  \n']);
fprintf(fid,[ 'CROSS_BEAM_ELEMENTS, GRAV, 9.81, 0 , 0 , -1  \n']);
fprintf(fid,[ 'PYLON_ELEMENTS, GRAV, 9.81, 0 , 0 , -1  \n']);
fprintf(fid,[ 'PYLON_BEAM_ELEMENTS, GRAV, 9.81, 0 , 0 , -1  \n']);
fprintf(fid,[ '**  \n']);

%Outputs
fprintf(fid,[ '*OUTPUT, FIELD  \n']);
fprintf(fid,[ '*Node Output \n']);
fprintf(fid,[ 'RF, U, UR \n']);
fprintf(fid,[ '**  \n']);
fprintf(fid,[ '*OUTPUT, FIELD   \n']);
fprintf(fid,[ '*Element Output  \n']);
fprintf(fid,[ 'SF  \n']);
fprintf(fid,[ '**  \n']);

%End step
fprintf(fid,[ '**    \n']);
fprintf(fid,[ '**   \n ']);
fprintf(fid,[ '*END STEP   \n ']);

%% Step 4: Frequency step
fprintf(fid,[ '**  Frequency step \n']);
fprintf(fid,[ '*STEP,NLGEOM \n']);
fprintf(fid,[ '*FREQUENCY  \n']); %NORMALIZATION=DISPLACEMENT
fprintf(fid,[ '100, ,  \n']);
fprintf(fid,[ '**  \n']);

fprintf(fid,[ '*BOUNDARY,OP=NEW  \n']);
formatSpec = '%.0f,%.0f,%.0f,%.0f \n';

bc_girder_step3 = [bc_1,1,4,0;bc_2,2,4,0;bc_3,2,4,0;bc_4,2,4,0;bc_5,2,4,0;bc_6,2,4,0];%
% bc_cable_top= [bc_7,2,3,0;bc_8,2,3,0;bc_9,2,3,0;bc_10,2,3,0];
bc_cable_end=[bc_11,1,6,0;bc_12,1,6,0;bc_13,1,6,0;bc_14,1,6,0];
bc_pylon_step3 = [bc_18,1,6,0;bc_19,1,6,0;bc_20,1,6,0;bc_21,1,6,0];

fprintf(fid,formatSpec,bc_girder_step3'); %Girder BC
% fprintf(fid,formatSpec,bc_cable_top'); %Cable BC
fprintf(fid,formatSpec,bc_cable_end'); %Cable BC
fprintf(fid,formatSpec,bc_pylon_step3'); %Pylon BC

if number_of_girders==2
bc_girder_step3 = [bc_1,1,4,0;bc_2,2,4,0;bc_3,1,4,0;bc_4,2,4,0;bc_5,1,4,0;bc_6,2,4,0];
end
%Output
fprintf(fid,[ '**Request displacements and rotations  \n']);
fprintf(fid,[ '*OUTPUT, FIELD  \n']);
fprintf(fid,[ '*Node Output \n']);
fprintf(fid,[ 'U, UR \n']);
fprintf(fid,[ '*OUTPUT, HISTORY  \n']);
fprintf(fid,[ '*NODE PRINT, MODE=1,LAST MODE=100,NSET=GIRDERNODES  \n']);
fprintf(fid,[ 'COORD, U, UR \n']);
fprintf(fid,[ '*END STEP   \n ']);
fprintf(fid,[ '**   \n ']);
 %%
clc

end